{% extends "materiel.html" %}
{% load materiel_filter icon %}

{% block title %}
    Gestion des emprunts
{% endblock %}

{% block content %}

    <header>
        <h1>Gestion des emprunts</h1>

        <div class="header-content">
            <p>
                Depuis cette page, vous pouvez gérer les demandes d'emprunts réalisées par tous les utilisateurs du
                site.<br/>
                Pour traiter un emprunt, vous devez valider ou refuser chaque élément de cet emprunt. Vous pouvez
                associer
                un commentaire à une validation, ainsi qu'un commentaire à toute la demande.
                <strong>Attention, si vous validez tous les éléments d'un emprunt, vous ne pourrez plus rajouter
                    d'élément.</strong>
            </p>
            <p>
                {% if emprunts_retards %}
                    Il y a <strong>{{ emprunts_retards|length }} emprunt{{ emprunts_retards|length|pluralize }}</strong>
                    en retard.<br/>
                {% endif %}
                {% if emprunts_en_attente %}
                    Il y a
                    <strong>{{ emprunts_en_attente|length }} emprunt{{ emprunts_en_attente|length|pluralize }}</strong>
                    en attente.<br/>
                {% endif %}
                {% if emprunts_a_venir %}
                    Il y a <strong>{{ emprunts_a_venir|length }} emprunt{{ emprunts_a_venir|length|pluralize }}</strong>
                    à venir.
                {% endif %}
            </p>
        </div>
    </header>

    <div class="container-fluid">
        {% if emprunts_retards %}
            <h2 class="title">Emprunts en retards</h2>

            <section>
                {% for emprunt in emprunts_retards %}

                    {# Utilisateur qui a effectué l'emprunt #}
                    <div class="card card-lg">
                        <div class="card-body">
                            <div class="row">
                                <div class="col-md-1">
                                    <img class="photo-matos" src="{% url "photo_utilisateur" emprunt.membre.id %}"
                                         alt="Photo de {{ emprunt.membre.nomComplet }}"/>
                                </div>
                                <div class="col-md-10">
                                    <h3>{{ emprunt.membre.nomComplet }}</h3>
                                    <p>
                                        Du {{ emprunt.debut }} au {{ emprunt.fin }}
                                    </p>
                                    <p>
                                        <strong>Raison : </strong>
                                        {{ emprunt.description }}<br/>
                                        <a data-toggle="collapse" href="#details-{{ emprunt.id }}" class="data-toggle">
                                            Détails <i class="far fa-caret-square-down"></i>
                                        </a>
                                    </p>
                                </div>
                            </div>

                            {# Ligne d'un élément de l'emprunt #}
                            <div class="collapse" id="details-{{ emprunt.id }}">
                                {% for matos in matos_emprunt_retard %}
                                    {% if matos.emprunt.id == emprunt.id %}
                                        <div class="row" id="emprunt-element-{{ matos.id }}">
                                            <div class="offset-1 col-md-1">
                                                <img class="photo-matos"
                                                     src="{% url 'photo_materiel' matos.materiel.id %}"
                                                     name="{{ matos.id }}" alt="Photo du {{ matos.materiel.nom }}"/>
                                            </div>
                                            <div class="col-md-3">
                                                <h5>{{ matos.materiel.nom|truncatechars:22 }}</h5>
                                                {% if matos.quantite != 1 %}
                                                    <span class="subtext">Quantité : {{ matos.quantite }}</span><br/>
                                                {% endif %}
                                            </div>
                                            <div class="col-md-4">
                                                <p>{{ matos.commentaire }}</p>
                                            </div>

                                            <div class="col-md-2" id="element-{{ matos.id }}">
                                                {% if matos.statut == statut_valide %}
                                                    <button type="button" class="btn btn-success"
                                                            onclick="changer_statut({{ matos.id }}, {{ emprunt.id }}, 2)">
                                                        Rendu
                                                    </button>
                                                {% elif matos.statut == statut_refuse %}
                                                    <i class="far fa-times-circle fa-lg"></i>
                                                {% elif matos.statut == statut_rendu %}
                                                    <i class="far fa-check-circle fa-lg"></i>
                                                {% endif %}
                                            </div>
                                        </div>
                                    {% endif %}
                                {% endfor %}
                                {% if emprunt.commentaire %}
                                    <div class="row">
                                        <div class="offset-2 col-8">
                                            <div class="form-group">
                                                <label for="commentaire-{{ emprunt.id }}"><strong>Commentaire
                                                    (de {{ emprunt.auteurCommentaire.nomComplet }}) :</strong></label>
                                                {{ emprunt.commentaire }}
                                            </div>
                                        </div>
                                    </div>
                                {% endif %}
                            </div>
                        </div>
                    </div>
                {% empty %}
                    <p>Il n'y a pas d'emprunt en retard.</p>
                {% endfor %}
            </section>
        {% endif %}

        <h2 class="title">Emprunts en attente</h2>

        <section>
            {% for emprunt in emprunts_en_attente %}

                {# Utilisateur qui a effectué l'emprunt #}
                <div class="card card-lg" id="emprunt-{{ emprunt.id }}">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-1">
                                <img class="photo-matos" src="{% url "photo_utilisateur" emprunt.membre.id %}"
                                     alt="Photo de {{ emprunt.membre.nomComplet }}"/>
                            </div>
                            <div class="col-md-7">
                                <h3>{{ emprunt.membre.nomComplet }}</h3>
                                <p>
                                    Du {{ emprunt.debut }} au {{ emprunt.fin }}

                                    {% if emprunt in emprunts_conflits %}
                                        <br/><span class="subtext-important">Conflits présents dans cet emprunt</span>
                                    {% endif %}
                                    {% if emprunt.membre|location %}
                                        <br/>
                                        <span class="subtext-important">Cet emprunt est une location payante !</span>
                                    {% endif %}
                                    {% if emprunt.membre.statutCotisation == "ATT" %}
                                        <span class="subtext-important">Cotisation non-payée !</span>
                                    {% endif %}
                                </p>
                                <p>
                                    <strong>Raison : </strong>
                                    {{ emprunt.description }}<br/>
                                    <a data-toggle="collapse" href="#details-{{ emprunt.id }}" class="data-toggle">
                                        Détails <i class="far fa-caret-square-down"></i>
                                    </a>
                                </p>
                            </div>
                            <div class="col-md-2">
                                {% if emprunt not in emprunts_conflits %}
                                    <span class="btn-group">
                                        <button type="button" class="btn btn-success"
                                                href="javascript:changer_statut_emprunt({{ emprunt.id }}, 1)"
                                                data-toggle="confirmation" data-btn-ok-label="Oui"
                                                data-btn-cancel-label="Annuler" data-btn-cancel-class="btn-light"
                                                data-title="Vous êtes sûr ?">Valider tout l'emprunt</button>

                                        <button type="button" class="btn btn-danger"
                                                href="javascript:changer_statut_emprunt({{ emprunt.id }}, 0)"
                                                data-toggle="confirmation" data-btn-ok-label="Oui"
                                                data-btn-cancel-label="Annuler" data-btn-cancel-class="btn-light"
                                                data-title="Vous êtes sûr ?">Refuser tout l'emprunt</button>
                                    </span>
                                {% endif %}
                            </div>
                        </div>

                        {# Ligne d'un élément de l'emprunt #}
                        <div class="collapse" id="details-{{ emprunt.id }}">
                            {% for matos in matos_emp_en_attente %}
                                {% if matos.emprunt.id == emprunt.id %}
                                    <div class="row {% if matos in matos_emp_conflit %} conflit {% endif %}{% if matos in matos_emp_conflit_gere %}conflit-important{% endif %}"
                                         id="emprunt-element-{{ matos.id }}">
                                        <div class="offset-1 col-md-1">
                                            <img class="photo-matos" src="{% url 'photo_materiel' matos.materiel.id %}"
                                                 name="{{ matos.id }}" alt="Photo du {{ matos.materiel.nom }}"/>
                                        </div>
                                        <div class="col-md-3">
                                            <h5>{{ matos.materiel.nom|truncatechars:22 }}</h5>
                                            {% if matos.quantite != 1 %}
                                                <span class="subtext">Quantité : {{ matos.quantite }}</span><br/>
                                            {% endif %}
                                            {% if matos in matos_emp_conflit %}
                                                <span class="subtext-important">Conflit avec un autre élément
                                                    {% if matos in matos_emp_conflit_gere %}déjà validé{% endif %}
                                                    !</span>
                                            {% endif %}
                                        </div>
                                        <div class="col-md-4">
                                            {% if matos.statut == statut_en_attente %}
                                                <input type="text" class="form-control" style="width: 100%"
                                                       placeholder="Commentaire de l'élément"
                                                       id="comment-element-{{ matos.id }}"/>
                                            {% else %}
                                                <p>{{ matos.commentaire }}</p>
                                            {% endif %}
                                        </div>

                                        <div class="col-md-2" id="element-{{ matos.id }}">
                                            {% if matos.statut == statut_valide %}
                                                <i class="far fa-check-circle fa-lg"></i>
                                            {% elif matos.statut == statut_refuse %}
                                                <i class="far fa-times-circle fa-lg"></i>
                                            {% else %}
                                                <div class="btn-group">
                                                    {% if matos in matos_emp_conflit_gere %}
                                                        <button type="button" class="btn btn-success disabled">Valider
                                                        </button>
                                                    {% elif matos in matos_emp_conflit %}
                                                        <button type="button" class="btn btn-success"
                                                                onclick="changer_statut({{ matos.id }}, {{ emprunt.id }}, 1, 1)">
                                                            Valider
                                                        </button>
                                                    {% else %}
                                                        <button type="button" class="btn btn-success"
                                                                onclick="changer_statut({{ matos.id }}, {{ emprunt.id }}, 1)">
                                                            Valider
                                                        </button>
                                                    {% endif %}
                                                    {% if matos in matos_emp_conflit %}
                                                        <button type="button" class="btn btn-danger"
                                                                onclick="changer_statut({{ matos.id }}, {{ emprunt.id }}, 0, 1)">
                                                            Refuser
                                                        </button>
                                                    {% else %}
                                                        <button type="button" class="btn btn-danger"
                                                                onclick="changer_statut({{ matos.id }}, {{ emprunt.id }}, 0)">
                                                            Refuser
                                                        </button>
                                                    {% endif %}
                                                </div>
                                            {% endif %}
                                        </div>
                                    </div>
                                {% endif %}
                            {% endfor %}
                            <div class="row">
                                <div class="offset-2 col-8">
                                    <div class="form-group">
                                        <label for="add-element-{{ emprunt.id }}"><a aria-expanded="false"
                                                                                     href="#add-element-{{ emprunt.id }}"
                                                                                     data-toggle="collapse">
                                            <i class="fas fa-plus-circle"></i> Ajouter un élément à
                                            l'emprunt</a></label>
                                        <div class="collapse" id="add-element-{{ emprunt.id }}">
                                            <input type="text" id="hello" class="form-control"
                                                   placeholder="Elément à rajouter"/>
                                            <div class="results list-group">
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="offset-2 col-8">
                                    <div class="form-group">
                                        <label for="commentaire-{{ emprunt.id }}"><strong>Commentaire :</strong></label>
                                        <textarea placeholder="Commentaire général de l'emprunt"
                                                  id="commentaire-{{ emprunt.id }}" rows="3"
                                                  class="form-control">{% if emprunt.commentaire %}
                                            {{ emprunt.commentaire }}{% endif %}</textarea>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            {% empty %}
                <p>Il n'y a pas d'emprunt en attente </p>
            {% endfor %}
        </section>

        <h2 class="title">Emprunts à venir</h2>

        <section>
            {% for emprunt in emprunts_a_venir %}

                {# Utilisateur qui a effectué l'emprunt géré #}
                <div class="card card-lg">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-1">
                                <img class="photo-matos" src="{% url "photo_utilisateur" emprunt.membre.id %}"
                                     alt="Photo de {{ emprunt.membre.nomComplet }}"/>
                            </div>
                            <div class="col-md-10">
                                <h4>{{ emprunt.membre.nomComplet }}</h4>
                                <p>
                                    Du {{ emprunt.debut }} au {{ emprunt.fin }}
                                    {% if emprunt.membre|location %}
                                        <br/>
                                        <span class="subtext-important">Cet emprunt est une location payante !</span>
                                    {% endif %}
                                </p>
                                <p>
                                    <strong>Raison : </strong>
                                    {{ emprunt.description }}<br/>
                                    <a data-toggle="collapse" href="#details-{{ emprunt.id }}" class="data-toggle">
                                        Détails <i class="far fa-caret-square-down"></i>
                                    </a>
                                </p>
                            </div>
                        </div>

                        {# Ligne d'un élément de l'emprunt traité #}
                        <div class="collapse" id="details-{{ emprunt.id }}">
                            {% for matos in matos_emp_gere %}
                                {% if matos.emprunt.id == emprunt.id %}
                                    <div class="row">
                                        <div class="offset-1 col-md-1">
                                            <img class="photo-matos" src="{% url 'photo_materiel' matos.materiel.id %}"
                                                 name="{{ matos.id }}" alt="Photo du {{ matos.nom }}"/>
                                        </div>
                                        <div class="col-md-3">
                                            <h5>{{ matos.materiel.nom|truncatechars:22 }}</h5>
                                            {% if matos.quantite != 1 %}
                                                <span class="subtext">Quantité : {{ matos.quantite }}</span>
                                            {% endif %}
                                        </div>

                                        <div class="col-md-4">
                                            <p>{{ matos.commentaire }}</p>
                                        </div>

                                        <div class="col-md-2">
                                            {% if matos.statut == statut_valide %}
                                                <i class="far fa-check-circle fa-lg"></i>
                                                <button type="button" class="btn btn-success"
                                                        onclick="changer_statut({{ matos.id }}, {{ emprunt.id }}, 2)">
                                                    Rendu
                                                </button>
                                            {% elif matos.statut == statut_refuse %}
                                               <i class="far fa-times-circle fa-lg"></i>
                                            {% endif %}
                                        </div>
                                    </div>
                                {% endif %}
                            {% endfor %}

                            {% if emprunt.commentaire %}
                                <div class="row">
                                    <div class="offset-2 col-8">
                                        <div class="form-group">
                                            <label for="commentaire-{{ emprunt.id }}"><strong>Commentaire
                                                (de {{ emprunt.auteurCommentaire.nomComplet }}) :</strong></label>
                                            {{ emprunt.commentaire }}
                                        </div>
                                    </div>
                                </div>
                            {% endif %}
                        </div>
                    </div>
                </div>
            {% empty %}
                <p>Il n'y a pas d'emprunt gérés </p>
            {% endfor %}
        </section>

        <h2 class="title">Emprunts terminés</h2>

        <section>
            {% for emprunt in emprunts_termines %}

                {# Utilisateur qui a effectué l'emprunt géré #}
                <div class="card card-lg">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-1">
                                <img class="photo-matos" src="{% url "photo_utilisateur" emprunt.membre.id %}"
                                     alt="Photo de {{ emprunt.membre.nomComplet }}"/>
                            </div>
                            <div class="col-md-10">
                                <h4>{{ emprunt.membre.nomComplet }}</h4>
                                <p>
                                    Du {{ emprunt.debut }} au {{ emprunt.fin }}
                                </p>
                                <p>
                                    <strong>Raison : </strong>
                                    {{ emprunt.description }}<br/>
                                    <a data-toggle="collapse" href="#details-{{ emprunt.id }}" class="data-toggle">
                                        Détails <i class="far fa-caret-square-down"></i>
                                    </a>
                                </p>
                            </div>
                        </div>

                        {# Ligne d'un élément de l'emprunt traité #}
                        <div class="collapse" id="details-{{ emprunt.id }}">
                            {% for matos in matos_emprunt_termine %}
                                {% if matos.emprunt.id == emprunt.id %}
                                    <div class="row">
                                        <div class="offset-1 col-md-1">
                                            <img class="photo-matos" src="{% url 'photo_materiel' matos.materiel.id %}"
                                                 name="{{ matos.id }}" alt="Photo du {{ matos.nom }}"/>
                                        </div>
                                        <div class="col-md-3">
                                            <h5>{{ matos.materiel.nom|truncatechars:22 }}</h5>
                                            {% if matos.quantite != 1 %}
                                                <span class="subtext">Quantité : {{ matos.quantite }}</span>
                                            {% endif %}
                                        </div>

                                        <div class="col-md-4">
                                            <p>{{ matos.commentaire }}</p>
                                        </div>

                                        <div class="col-md-2">
                                            {% if matos.statut == statut_valide %}
                                                <i class="far fa-check-circle fa-lg"></i>
                                            {% elif matos.statut == statut_refuse %}
                                                <i class="far fa-times-circle fa-lg"></i>
                                            {% endif %}
                                        </div>
                                    </div>
                                {% endif %}
                            {% endfor %}

                            {% if emprunt.commentaire %}
                                <div class="row">
                                    <div class="offset-2 col-8">
                                        <div class="form-group">
                                            <label for="commentaire-{{ emprunt.id }}"><strong>Commentaire
                                                (de {{ emprunt.auteurCommentaire.nomComplet }}) :</strong></label>
                                            {{ emprunt.commentaire }}
                                        </div>
                                    </div>
                                </div>
                            {% endif %}
                        </div>
                    </div>
                </div>
            {% empty %}
                <p>Il n'y a pas d'emprunt terminés.</p>
            {% endfor %}
        </section>
    </div>
{% endblock %}

{% block footer_javascript %}
    {# Plugin confirmation box #}
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-confirmation2@4.0.0/dist/bootstrap-confirmation.min.js"></script>

    <script type="text/javascript">
        $(function () {
            $('[data-toggle=confirmation]').confirmation({
                rootSelector: '[data-toggle=confirmation]'
            });

            let search_boxes = $('div[id^="add-element-"] input');
            search_boxes.on('input', function () {
                let input = $(this);
                if (input.val() !== '') {
                    let id_emprunt = input.parent().attr('id').substr(12);
                    $.ajax({
                        url: '{% url 'search_materiel' %}',
                        data: {
                            'emprunt': id_emprunt,
                            'texte': input.val(),
                            'csrfmiddlewaretoken': '{{ csrf_token }}'
                        },
                        type: 'post',
                        dataType: 'json',
                        success: function (data) {
                            let results = $('#' + input.parent().attr('id') + ' .results');
                            if (data['results']) {
                                results.html('');
                                if (data['results'].length > 0) {
                                    data['results'].forEach(function (elem) {
                                        results.append('<a onclick="add_element_emprunt(' + id_emprunt + ',' + elem[0] + ')" class="list-group-item list-group-item-action">' + elem[1] + '</a>');
                                    });
                                } else {
                                    results.append('<li class="list-group-item">Aucun matériel correspondant n\'est disponible !</li>');
                                }
                            }
                        }
                    });
                } else {
                    $('#' + input.parent().attr('id') + ' .results').html('');
                }
            });

            search_boxes.blur(function () {
                setTimeout(() => {
                    $('#' + $(this).parent().attr('id') + ' .results').html('');
                }, 100);
            })
        });

        function changer_statut_emprunt(id_emprunt, valider) {
            $('#details-' + id_emprunt + ' [id^="emprunt-element-"').each((index, element) => {
                changer_statut(element.id.substring(16), id_emprunt, valider);
            });
        }

        function changer_statut(id, id_emprunt, valider, force_reload = 0) {
            $.ajax({
                url: '{% url 'emprunt_statut' %}',
                data: {
                    'valider': valider,
                    'id': id,
                    'commentaire': (valider !== 2) ? $('#comment-element-' + id).val() : '',
                    'commentaireEmprunt': (valider !== 2) ? $('#commentaire-' + id_emprunt).val() : '',
                    'csrfmiddlewaretoken': '{{ csrf_token }}'
                },
                type: 'post',
                dataType: 'json',
                success: function (data) {
                    $('#comment-element-' + id).parent().html($('#comment-element-' + id).val());
                    $('#element-' + id).html('<i class="far fa-' + (valider ? 'check' : 'times') + '-circle fa-lg"></i>');
                    if (data['nb_en_attente'] === 0 || force_reload) {
                        location.reload();
                    }
                }
            });
        }

        function add_element_emprunt(id_emprunt, id_matos) {
            console.log("Ajout du matos " + id_matos + " à l'emprunt " + id_emprunt);
            $.ajax({
                url: '{% url 'ajout_emprunt_element' %}',
                data: {
                    'id_emprunt': id_emprunt,
                    'id_matos': id_matos,
                    'csrfmiddlewaretoken': '{{ csrf_token }}'
                },
                type: 'post',
                dataType: 'json',
                success: function (data) {
                    location.reload();
                }
            });
        }

    </script>
{% endblock %}